﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class Enemy_Behavior : MonoBehaviour {

	public GameObject Enemy_Laser;
	
	private float laser_speed = 5f;
	public float health;
	public float shots_per_second;
	public int scoreValue = 150;
	
	private ScoreKeeper scoreKeeper;
	
	void Start(){
		scoreKeeper = GameObject.Find ("Score").GetComponent<ScoreKeeper>();
	}	
	void Update(){
		float probability = Time.deltaTime * shots_per_second;
		if(Random.value < probability){
		
		_Attack();
		
		}
	}

	void _Attack(){
		Vector3 startPosition = new Vector3(0f,-1.5f, 0f);
		Vector3 firePos = transform.position + startPosition;
		GameObject Red_Laser = Instantiate(Enemy_Laser, firePos, Quaternion.identity) as GameObject;
		Red_Laser.rigidbody2D.velocity = new Vector2(0,-laser_speed);
	}

	void OnTriggerEnter2D(Collider2D collider){
	
		Projectile missile = collider.gameObject.GetComponent<Projectile>();
		
		if(missile){
			health -= missile.GetDamage();
			missile.Hit();
			if (health <= 0){
				Destroy (gameObject);
				scoreKeeper.Score(scoreValue);
			}
		}
	}
}
