﻿using UnityEngine;
using System.Collections;
using UnityEditor;

public class PlayerController : MonoBehaviour {

	public GameObject laserPrefab;
	public float speed;
	public float padding;
	public float laser_speed;
	public float firing_rate;
	public float player_health;
	
	public AudioClip fireSound;
	
	float x_min;
	float x_max;
		
	void Start(){
		float distance = transform.position.z - Camera.main.transform.position.z;
		Vector3 left_most = Camera.main.ViewportToWorldPoint(new Vector3(0,0,distance));
		Vector3 right_most = Camera.main.ViewportToWorldPoint(new Vector3(1,0,distance));
		x_min = left_most.x + padding;
		x_max = right_most.x - padding;
	}
	
	void Update () {
	
		Shoot_Laser();
	
		if (Input.GetKey(KeyCode.LeftArrow)){
			transform.position += Vector3.left * speed * Time.deltaTime;	
		}else if (Input.GetKey(KeyCode.RightArrow)){
			transform.position += Vector3.right * speed * Time.deltaTime;
		}
		// restrict the player to the gamespace
		float new_x = Mathf.Clamp (transform.position.x, x_min, x_max);
		transform.position = new Vector3(new_x, transform.position.y, transform.position.z);
	}
	void Shoot_Laser(){
		if (Input.GetKeyDown (KeyCode.Space)){
			InvokeRepeating ("Fire", 0.000001f, firing_rate);
		}
		if (Input.GetKeyUp (KeyCode.Space)) {
			CancelInvoke ("Fire");
		}
	}
	void Fire(){
		GameObject Laser = Instantiate(laserPrefab, transform.position, Quaternion.identity) as GameObject;
		Laser.rigidbody2D.velocity = new Vector3(0,laser_speed,0);
		AudioSource.PlayClipAtPoint (fireSound,transform.position);
	}
	
	void OnTriggerEnter2D(Collider2D collider){
		
		Enemy_Projectile red_death = collider.gameObject.GetComponent<Enemy_Projectile>();
		
		if(red_death){
			player_health -= red_death.GetDamage();
			red_death.Hit();
			if (player_health <= 0){
				Destroy (gameObject);
			}
		}
	}
}
